<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<!DOCTYPE html>
<html>
<head>
    <style media="screen">
        * {
            box-sizing: border-box;
        }

        html, body {
            margin: 0;
            padding: 0;
            width: 100%;
            height: 100%;
        }

        .container {
            width: 100%;
            height: 100%;
            /*padding-right: 210px;*/
            position: relative;
        }

        .view {
            height: 100%;
        }

        .right-bar {
            position: absolute;
            right: 0;
            top: 0;
            width: 210px;
            height: 100%;
            border-left: 1px solid #d8d8d8;
            vertical-align: top;
        }

        .title {
            height: 36px;
            border-bottom: 1px solid #d8d8d8;
            padding: 0 10px;
            line-height: 36px;
        }

        .button {
            padding: 7px 24px;
            border-radius: 3px;
            margin-right: 10px;
        }

        .add {
            color: #ffffff;
            background: #11dab7;
        }

        .cancel {
            border: 1px solid #11dab7;
            color: #11dab7;
        }

        .edit {
            display: none;
            padding: 10px;
            border-bottom: 1px solid #d8d8d8;
        }

        .textarea {
            width: 100%;
            height: 90px;
            border: 1px solid #ccc;
            resize: none;
            outline: none;
        }

        .tips {
            padding: 10px;
            font-size: 14px;
            color: #666;
        }

        .new {
            padding: 10px;
        }

        video {
            object-fit:fill;
            width:800px;
            height:554px;
        }
    </style>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>中国人民解放军总医院</title>
    <%--<link rel="stylesheet" href="<%=request.getContextPath() %>/static/bim/css/sample.css">--%>
    <!-- 引用BIMFACE的JavaScript显示组件库 -->
    <script src="https://static.bimface.com/api/BimfaceSDKLoader/BimfaceSDKLoader@latest-release.js"
            charset="utf-8"></script>
<%--    <script src="https://cdn.bootcdn.net/ajax/libs/jquery/3.5.1/jquery.min.js"></script>--%>
    <script src="${pageContext.request.contextPath }/js/jquery-3.5.1.min.js"></script>
    <script src="${pageContext.request.contextPath }/layer/layer.js"></script>
</head>

<body>
<div class="header"></div>
<%--<div class="tips">第二步：调用服务端API获取ViewToken，并对接JS显示组件打开模型</div>--%>
<%--<div class="box">--%>
<%--	<div class="viewer" id="domId"></div>--%>
<%--	<input type="button" class="button add"    value="显示标签" id="getAll">--%>

<%--</div>--%>
<audio id="myAudio">
    <source src="https://bcxin-pss-test.obs.cn-north-1.myhuaweicloud.com/BIM-audio1.mp3" type="audio/mp3">
    您的浏览器不支持 audio 元素。
</audio>
<div class="container">
    <div class="view" id="domId"></div>
    <div class="right-bar"  >
        <div class="title">侧边工具栏</div>
<%--        <div class="new" >--%>
<%--            <input type="button" class="button add" value="设置HOME视图" id="btnCustomView" onclick="customView()">--%>
<%--        </div>--%>
        <div class="new" >
            &nbsp;
        </div>
        <div class="new" >
            &nbsp;
        </div>
        <div class="new" >
            &nbsp;
        </div>
        <div class="tips" id="myTips"></div>
        <div class="edit" id="edit">
            <textarea id="textarea" class="textarea"></textarea>
            <button class="button add" id="save">保存</button>
            <button class="button cancel" id="cancel">取消</button>
        </div>
        <div class="new"   >
            <input type="button" class="button add" value="新建标签" id="new">
        </div>
        <div class="new"   >
            <input type="button" class="button add" value="删除标签" id="deleteLabel" onclick="deleteLabel()">
        </div>
        <div class="new">
            <input type="button" class="button add" value="隐藏全部" id="getAll" onclick="clearItems()">
        </div>
        <div class="new">
            <input type="button" class="button add" value="显示全部" id="showItems" onclick="showItems()">
        </div>
    </div>
</div>
<script type="text/javascript">

    var viewer, drawable, selectedLabel;
    // 指定待显示的模型或图纸（viewToken从服务端获取）
    var viewToken = '<%=request.getAttribute("viewToken")%>';

    var cameraState = {
        "name":"persp",
        "position":{
            "x":270899.1818873149,
            "y":1506365.3434006798,
            "z":38461.041745632494
        },
        "target":{
            "x":270899.1818873149,
            "y":583856.709079089,
            "z":38461.0014215012
        },
        "up":{
            "x":0,
            "y":4.3711324009003633e-8,
            "z":0.9999999999932538
        },
        "fov":45
    };

    // 配置JSSDK加载项
    window.onload = function () {
        var loaderConfig = new BimfaceSDKLoaderConfig();
        loaderConfig.viewToken = viewToken;
        BimfaceSDKLoader.load(loaderConfig, successCallback, failureCallback);
    }

    function successCallback(viewMetaData) {
        // 创建WebApplication，直接显示模型或图纸
        var dom4Show = document.getElementById('domId');
        // 设置WebApplication3D的配置项
        var webAppConfig = new Glodon.Bimface.Application.WebApplication3DConfig();
        webAppConfig.domElement = dom4Show;
        // 创建WebApplication3D，用以显示模型
        app = new Glodon.Bimface.Application.WebApplication3D(webAppConfig);
        app.addView(viewToken);
        viewer = app.getViewer();
        //viewer.setExposureShift(-0.3);//默认曝光度设置为3
        //自适应屏幕大小
        window.onresize = function () {
            viewer.resize(document.documentElement.clientWidth, document.documentElement.clientHeight - 40)
        }


        var drawableConfig = new Glodon.Bimface.Plugins.Drawable.DrawableContainerConfig();
        drawableConfig.viewer = viewer;
        drawableConfig.maxNum = 100;
        drawable = new Glodon.Bimface.Plugins.Drawable.DrawableContainer(drawableConfig);

        app.addEventListener(Glodon.Bimface.Viewer.Viewer3DEvent.ViewAdded, function () {
            // drawing3D();
            setCameraStatus();
            initDrawing3D();
        });
    }
    function failureCallback(error) {
        console.log(error);
    }

    function setCameraStatus() {
        viewer.setCameraStatus(cameraState);
    }

    var homeview;
    var viewAdded = false;
    function customView() {
        // if (!viewAdded) {
        //     return;
        // } else {
            homeview = viewer.getCameraStatus();
            viewer.recordCustomHomeview(homeview);
            window.alert(JSON.stringify(homeview));
            console.log(JSON.stringify(homeview));
            viewer.render();
        // }
    }
    //初始化加载
    function initDrawing3D() {
        // var tagArr = [];
        var positions=${positions};
        var texts=${texts};
        var labelIds=${labelIds};

        //handler other labels
        for (var i = 0; i < positions.length; i++) {
            var imageConfig = new Glodon.Bimface.Plugins.Drawable.LeadLabelConfig();
            imageConfig.text=texts[i];
            imageConfig.worldPosition = positions[i];
            var image = new Glodon.Bimface.Plugins.Drawable.LeadLabel(imageConfig);
            //引线标签的双击事件
            image.onDoubleClick(function (item) {
                newButton.style.display = "none";
                edit.style.display = "block";
                textarea.value = item.getText();
                data.item = item;
            });

            //引线标签的左键点击事件
            image.onClick(function (item) {
                console.log(image.getObjectId(item.id));
                console.log(item)
                selectedLabel = item;
            });
            image.id=labelIds[i];
            drawable.addItem(image);
        }

    }

    var edit = document.getElementById("edit"),
        textarea = document.getElementById("textarea"),
        myTips = document.getElementById("myTips"),
        newButton = document.getElementById("new"),
        saveButton = document.getElementById("save"),
        cancelButton = document.getElementById("cancel"),
        getAllButton = document.getElementById("getAll"),

        data = {};
    var clickEvent = function (componentData) {
        if (componentData && componentData.objectId) {
            myTips.style.display = "none";
            edit.style.display = "block";
            data.componentId = componentData.objectId;
            data.worldPosition = componentData.worldPosition;
        } else {
            myTips.innerText = "请选择一个合适的位置。";
            myTips.style.display = "block";
        }
    }
    var saveFn = function () {
        var text = textarea.value;
        if (!text.trim()) {
            myTips.innerText = "标签内容不能为空。";
            myTips.style.display = "block";
            return false;
        }
        if (data.item) {
            data.item.setText(text);
            saveLabelToDb(JSON.stringify(data.worldPosition),text,data.item.id);
        } else {

            //引线标签的配置类
            var config = new Glodon.Bimface.Plugins.Drawable.LeadLabelConfig();
            //引线标签的内容
            config.text = text;
            //引线标签关联的构件
            config.objectId = data.componentId;
            //引线标签的世界坐标
            config.worldPosition = data.worldPosition;
            //引线标签是否可拖拽
            config.draggable = true;
            //引线标签的视图
            config.viewer = viewer;

            var label = new Glodon.Bimface.Plugins.Drawable.LeadLabel(config);
            //保存至数据库
            saveLabelToDb(JSON.stringify(data.worldPosition),text,label.id);
            //引线标签的双击事件
            label.onDoubleClick(function (item) {
                newButton.style.display = "none";
                edit.style.display = "block";
                textarea.value = item.getText();
                data.item = item;
            });

            //引线标签的左键点击事件
            label.onClick(function (item) {
                console.log(label.getObjectId(item.id));
                console.log(item)
                selectedLabel = item;
            })
            drawable.addItem(label);
            viewer.removeEventListener(Glodon.Bimface.Application.WebApplication3DEvent.ComponentsSelectionChanged, clickEvent);
        }
        data = {};
        textarea.value = "";
        edit.style.display = "none";
        myTips.style.display = "none";
        newButton.style.display = "block";
    }
    newButton.addEventListener("click", function () {
        viewer.addEventListener(Glodon.Bimface.Application.WebApplication3DEvent.ComponentsSelectionChanged, clickEvent);
        this.style.display = "none";
        myTips.innerText = "请在模型上选择标签位置。";
        myTips.style.display = "block";
    });

    saveButton.addEventListener("click", saveFn);

    cancelButton.addEventListener("click", function () {
        viewer.removeEventListener(Glodon.Bimface.Application.WebApplication3DEvent.ComponentsSelectionChanged, clickEvent);
        edit.style.display = "none";
        newButton.style.display = "block";
        textarea.value = "";
        data = {};
    })
    document.addEventListener("keyup", function (e) {
        var e = e || event;
        if (selectedLabel && (e.keyCode == 8 || e.keyCode == 46)) {
            drawable.removeItemById(selectedLabel.id);
            selectedLabel = null;
        }
    })

    function clearItems() {
        drawable.clear();
    }
    function showItems(){
        initDrawing3D();

    }

    function deleteLabel(){
        var labelId=selectedLabel.id;
        drawable.removeItemById(labelId);
        var fileId='${fileId}';

        $.ajax({
            url: '<c:url value="/bim/deleteLabel.json"/>',
            type: 'post',
            data: {
                fileId: fileId,
                viewToken:labelId,
            },
            dataType: 'json',
            success: function (data) {
                if (data.successful) {
                    layer.msg('删除标签成功', {time: 1000, icon: 1});
                } else {
                    layer.msg(data.msg);
                }
            }
        });

    }

    function saveLabelToDb(worldPosition,mytext,labelId){
        var fileId='${fileId}';
        var baseUrl = '${pageContext.request.contextPath }';

        $.ajax({
            url: '<c:url value="/bim/saveLabel.json"/>',
            type: 'post',
            data: {
                fileId: fileId,
                worldPosition: worldPosition,
                text: mytext,
                viewToken:labelId,
            },
            dataType: 'json',
            success: function (data) {
                if (data.successful) {
                    layer.msg('保存标签成功', {time: 1000, icon: 1});
                } else {
                    layer.msg(data.msg);
                }
            }
        });
    }
</script>
</body>
</html>


